/*
**	main.c
**
*/
#include "mpeg.h"
#define LL 1440
#define LN 486
#define SX 704
#define SY 480
#define SCX 352
#define SCY 240

struct sif { unsigned char y[SY][SX]; unsigned char c[2][SCY][SCX]; };
typedef struct	sif SIF;
SIF image;
int cmp,ddt,x2=1,vhs,bgc,wid,step,pause,sync=1;
double cur, startt, spent;
char name[20];

/*
**	ray.c
*/
struct poi{ float x; float y; float z; };
typedef struct poi Pt;
Pt point(x,y,z) { Pt p; p.x= x; p.y= y; p.z= z; return p; }
float ip(p,q) Pt p,q; { float r; r= p.x*q.x+ p.y*q.y + p.z*q.z; return r; }
Pt padd(a,b) Pt a,b; { a.x+=b.x; a.y+=b.y; a.z+=b.z; return a; }
Pt psub(a,b) Pt a,b; { a.x-=b.x; a.y-=b.y; a.z-=b.z; return a; }
Pt smp(k,p) float k; Pt p; { p.x*= k; p.y*= k; p.z*= k; return p; }
Pt norm(p)  Pt p; { return smp((float)sqrt(1./(p.x*p.x +p.y*p.y +p.z*p.z)),p); }

float cos1= 0.5;
float sin1= 1.7320508/2.;
float cos2= 0.9659;
float sin2= 0.2588;

Pt rotate(p) Pt p; { 
	float t;
	t=   p.x*cos1 -p.z*sin1;
	p.z= p.x*sin1 +p.z*cos1;
	p.x= t;
	t=   p.y*cos2 -p.z*sin2;
	p.z= p.y*sin2 +p.z*cos2;
	p.y= t;
	return p;
	}

float distant(a,v) Pt a,v; {
	float t1,t2,t3;
	float r;

	t1= a.x*v.y-a.y*v.x;
	t2= a.y*v.z-a.z*v.y;
	t3= a.z*v.x-a.x*v.z;
	r= t1*t1+t2*t2+t3*t3;
	return r;
	}

clr(i,j,p,v,ref)
Pt p,v;
	{
	float t;
	int	ix,iz;
	int	luma,cb,cr;
	int	up,cross,cross2=0;

	if(v.y<0) { t= (-SCY-p.y)/v.y; up= 0; }
	 else	  { t= (SCY-p.y)/v.y; up= 1; }
	ix= v.x*t+ p.x;
	iz= v.z*t+ p.z;
	if(up) ix= ix>>9;
	 else  ix= ix>>8;
	iz= iz>>8;
	cross= ((ix&1)==(iz&1));
	if(cross==0){
		if(v.y<0) t= (-SY*2-p.y)/v.y;
		 else	  t= (SY*2-p.y)/v.y;
		ix= v.x*t+ p.x;
		iz= v.z*t+ p.z;
		ix= ix>>9;
		iz= iz>>8;
		cross2= ((ix&1)==(iz&1));
		}
	luma= 40+cross2*80+cross*180;
	cb= 100+cross2*30+up*40;
	cr= 80+cross*25+ref*50;

	image.y[j][i]= luma;
	if((i&1)==0&&(j&1)==0){
		image.c[0][j/2][i/2]= cb;
		image.c[1][j/2][i/2]= cr;
		}
	}

lay(t0)
	{
	int	i,j;
	Pt eye,a,b;
	float c1,r0=300;

	for(j=0;j<SY;j++){
		float t= t0;//+0.5*(j&1);
		float r2=r0*r0;

		t= t+t*t/4;
		a= point(-500-(int)t,-100,(int)t); 
		eye= smp(0.5, a);

		b= psub(a,eye);
		c1= ip(b,b)-r2;

		for(i=0;i<SX;i++){
			int	ref=0;
			Pt p0= eye;
			Pt v= norm(rotate(point(i-SCX, SCY-j, SX)));

			if(distant(b,v)< r2) {
				float b1,k;
				Pt p1;
	
				b1= ip(b,v);
				p1= padd( eye, smp(b1-sqrt(b1*b1-c1), v) );
				k= -2.*ip(v,psub(p1,a))/r2;
				v= norm( padd( v, smp( k, psub(p1,a) ) ) );
				p0= p1;
				ref= 1;
				}
			clr(i,j,p0,v,ref);
			}
		}
	}

main(argc, argv) int argc; char	**argv;
	{
	int i;
	if(argc!=1){
		fprintf(stderr,"Usage: %s\n",argv[0]);
		exit(1);
		}
	iwt(argv[0],&image,704,480);
	for(i= 0;i<=1000;i++){
		lay(i);
		sprintf(name,"%s%0d",argv[0],i);
		wt(name,&image);
		if(pause){
			i--;
			if(step) { i+=step; step= 0;}
			usleep(100000);
			}
		}
	}
